pragma Warnings (Off);
pragma Ada_95;
pragma Source_File_Name (ada_main, Spec_File_Name => "b_gnatl.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b_gnatl.adb");
pragma Suppress (Overflow_Check);

package body ada_main is

   E012 : Short_Integer; pragma Import (Ada, E012, "ada__exceptions_E");
   E016 : Short_Integer; pragma Import (Ada, E016, "system__soft_links_E");
   E026 : Short_Integer; pragma Import (Ada, E026, "system__exception_table_E");
   E028 : Short_Integer; pragma Import (Ada, E028, "system__exceptions_E");
   E018 : Short_Integer; pragma Import (Ada, E018, "system__soft_links__initialize_E");
   E057 : Short_Integer; pragma Import (Ada, E057, "gnat_E");
   E122 : Short_Integer; pragma Import (Ada, E122, "interfaces__c_E");
   E124 : Short_Integer; pragma Import (Ada, E124, "interfaces__c__strings_E");
   E077 : Short_Integer; pragma Import (Ada, E077, "system__os_lib_E");
   E095 : Short_Integer; pragma Import (Ada, E095, "gnat__dynamic_htables_E");
   E061 : Short_Integer; pragma Import (Ada, E061, "system__assertions_E");
   E066 : Short_Integer; pragma Import (Ada, E066, "types_E");
   E107 : Short_Integer; pragma Import (Ada, E107, "gnatvsn_E");
   E062 : Short_Integer; pragma Import (Ada, E062, "hostparm_E");
   E120 : Short_Integer; pragma Import (Ada, E120, "indepsw_E");
   E059 : Short_Integer; pragma Import (Ada, E059, "opt_E");
   E075 : Short_Integer; pragma Import (Ada, E075, "output_E");
   E086 : Short_Integer; pragma Import (Ada, E086, "widechar_E");
   E082 : Short_Integer; pragma Import (Ada, E082, "namet_E");
   E056 : Short_Integer; pragma Import (Ada, E056, "butil_E");
   E118 : Short_Integer; pragma Import (Ada, E118, "casing_E");
   E099 : Short_Integer; pragma Import (Ada, E099, "fmap_E");
   E097 : Short_Integer; pragma Import (Ada, E097, "osint_E");
   E109 : Short_Integer; pragma Import (Ada, E109, "sdefault_E");
   E111 : Short_Integer; pragma Import (Ada, E111, "targparm_E");
   E093 : Short_Integer; pragma Import (Ada, E093, "fname_E");
   E116 : Short_Integer; pragma Import (Ada, E116, "snames_E");
   E054 : Short_Integer; pragma Import (Ada, E054, "ali_E");
   E128 : Short_Integer; pragma Import (Ada, E128, "switch_E");
   E002 : Short_Integer; pragma Import (Ada, E002, "gnatlink_E");

   Sec_Default_Sized_Stacks : array (1 .. 1) of aliased System.Secondary_Stack.SS_Stack (System.Parameters.Runtime_Default_Sec_Stack_Size);

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (Ada, s_stalib_adafinal, "system__standard_library__adafinal");

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;
   pragma Favor_Top_Level (No_Param_Proc);

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Default_Secondary_Stack_Size : System.Parameters.Size_Type;
      pragma Import (C, Default_Secondary_Stack_Size, "__gnat_default_ss_size");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
      Binder_Sec_Stacks_Count : Natural;
      pragma Import (Ada, Binder_Sec_Stacks_Count, "__gnat_binder_ss_count");
      Default_Sized_SS_Pool : System.Address;
      pragma Import (Ada, Default_Sized_SS_Pool, "__gnat_default_ss_pool");

   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;

      ada_main'Elab_Body;
      Default_Secondary_Stack_Size := System.Parameters.Runtime_Default_Sec_Stack_Size;
      Binder_Sec_Stacks_Count := 1;
      Default_Sized_SS_Pool := Sec_Default_Sized_Stacks'Address;

      Runtime_Initialize (1);

      Finalize_Library_Objects := null;

      Ada.Exceptions'Elab_Spec;
      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E026 := E026 + 1;
      System.Exceptions'Elab_Spec;
      E028 := E028 + 1;
      System.Soft_Links.Initialize'Elab_Body;
      E018 := E018 + 1;
      E016 := E016 + 1;
      E012 := E012 + 1;
      Gnat'Elab_Spec;
      E057 := E057 + 1;
      Interfaces.C'Elab_Spec;
      E122 := E122 + 1;
      Interfaces.C.Strings'Elab_Spec;
      E124 := E124 + 1;
      System.Os_Lib'Elab_Body;
      E077 := E077 + 1;
      E095 := E095 + 1;
      System.Assertions'Elab_Spec;
      E061 := E061 + 1;
      Types'Elab_Spec;
      E066 := E066 + 1;
      E107 := E107 + 1;
      Hostparm'Elab_Spec;
      E062 := E062 + 1;
      E120 := E120 + 1;
      Opt'Elab_Spec;
      E059 := E059 + 1;
      Output'Elab_Body;
      E075 := E075 + 1;
      E086 := E086 + 1;
      Namet'Elab_Spec;
      Namet'Elab_Body;
      E082 := E082 + 1;
      E056 := E056 + 1;
      E118 := E118 + 1;
      Osint'Elab_Spec;
      Fmap'Elab_Body;
      E099 := E099 + 1;
      E109 := E109 + 1;
      E111 := E111 + 1;
      Osint'Elab_Body;
      E097 := E097 + 1;
      E093 := E093 + 1;
      Snames'Elab_Body;
      E116 := E116 + 1;
      ALI'ELAB_SPEC;
      ALI'ELAB_BODY;
      E054 := E054 + 1;
      E128 := E128 + 1;
      E002 := E002 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_gnatlink");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      if gnat_argc = 0 then
         gnat_argc := argc;
         gnat_argv := argv;
      end if;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   ../rts/ada.o
   --   ../rts/interfac.o
   --   ../rts/system.o
   --   ../rts/s-addope.o
   --   ../rts/s-imgint.o
   --   ../rts/s-parame.o
   --   ../rts/s-crtl.o
   --   ../rts/i-cstrea.o
   --   ../rts/s-stoele.o
   --   ../rts/s-stache.o
   --   ../rts/s-strhas.o
   --   ../rts/s-htable.o
   --   ../rts/s-string.o
   --   ../rts/s-traent.o
   --   ../rts/s-unstyp.o
   --   ../rts/s-wchcon.o
   --   ../rts/s-wchjis.o
   --   ../rts/s-wchcnv.o
   --   ../rts/s-carun8.o
   --   ../rts/s-conca2.o
   --   ../rts/s-traceb.o
   --   ../rts/s-excdeb.o
   --   ../rts/s-wchstw.o
   --   ../rts/a-elchha.o
   --   ../rts/a-exctra.o
   --   ../rts/s-addima.o
   --   ../rts/s-exctab.o
   --   ../rts/s-except.o
   --   ../rts/s-excmac.o
   --   ../rts/s-memory.o
   --   ../rts/s-secsta.o
   --   ../rts/s-soliin.o
   --   ../rts/s-soflin.o
   --   ../rts/s-stalib.o
   --   ../rts/s-trasym.o
   --   ../rts/a-except.o
   --   ../rts/a-comlin.o
   --   ../rts/gnat.o
   --   ../rts/g-htable.o
   --   ../rts/i-c.o
   --   ../rts/i-cstrin.o
   --   ../rts/s-casuti.o
   --   ../rts/s-os_lib.o
   --   ../rts/g-dynhta.o
   --   ../rts/s-assert.o
   --   ./debug.o
   --   ./types.o
   --   ./alloc.o
   --   ./gnatvsn.o
   --   ./hostparm.o
   --   ./indepsw.o
   --   ./opt.o
   --   ./csets.o
   --   ./output.o
   --   ./rident.o
   --   ./table.o
   --   ./widechar.o
   --   ./namet.o
   --   ./butil.o
   --   ./casing.o
   --   ./fmap.o
   --   ./sdefault.o
   --   ./targparm.o
   --   ./osint.o
   --   ./fname.o
   --   ./snames.o
   --   ./ali.o
   --   ./switch.o
   --   ./gnatlink.o
   --   -L../rts/
   --   -L./
   --   -L/builddir/build/BUILD/gcc-11.5.0-20240719/gcc/ada/
   --   -L/usr/lib/gcc/aarch64-redhat-linux/11/adalib/
   --   -static
   --   -lgnat
--  END Object file/option list   

end ada_main;
